@echo off

REM BASICALLY impossible to write a .bat that 
REM gets COM_PORT variable from COMx.txt file and works in win2k/XP and also win98

if exist COMx.txt (
	FOR /F "tokens=1" %%i IN (COMx.txt) do echo COM_PORT=%%i

	rem failed attempts:
	rem FOR /F "eol=; tokens=1,2* delims==" %%i in (COMx.txt) do echo %i=%j		
	rem cmd /c COMx.bat
	echo found COMx.txt file with COM_PORT=%COM_PORT%
) else (
	set COM_PORT=COM1
	echo pretending COMx.txt file with COM_PORT=%COM_PORT%	
	rem TODO: make a default COMx.txt file ?
)

echo autosaving mcd and mct, to config dir
if exist config\autosaved_mcd.txt ren config\autosaved_mcd.txt config\autosaved_old_d.txt
tools\megaloader -c %COM_PORT% -o config\autosaved_mcd.txt
if exist config\autosaved_mct.txt ren config\autosaved_mct.txt config\autosaved_old_t.txt
tools\megaloader -c %COM_PORT% -a config\autosaved_mct.txt

rem TODO: check for sanity of the mcd,mct dumps, eg. non-0 length

if exist config\config.txt (
	echo You already have config.txt 
) else (
	echo Copying autosaved_mcd.txt to config.txt
	copy config\autosaved_mcd.txt config\config.txt
)

if exist config\tables.txt (
	echo You already have tables.txt 
) else (
	echo Copying autosaved_mct.txt to tables.txt
	copy config\autosaved_mct.txt config\tables.txt
)

echo Note that for the new firmware,
echo you might need to apply changes to config and tables manually,
echo than run generate_config.bat and upload_config.bat
echo after firmware uploaded. see Readme.html

echo Last chance to quit before firmware upgrade: CTRL-c to abort
echo -------------------------
pause

if exist firmware\vems.hex (
	tools\megaloader.exe firmware\vems.hex -wtE -c %COM_PORT% 
) else (
	echo Something went really wrong with your package, NO vems.hex file in firmware dir
)

rem echo Edit config. autosaved_mcd=> also run make mtt and upload these after this upgrade
rem echo Precompiled version: 12x12 Standard boost 
echo -----------------------------------------------------

pause

:END
